#include <sourcemod>
#include <sdkhooks>

#pragma semicolon 1
#pragma newdecls required

public Plugin myinfo = 
{
	name = "Reload Status",
	author = "Ranch",
	version = "1.1.1",
	url = "Ranch#0930"
};

bool reload[MAXPLAYERS + 1];

int offsetStart,
    offsetDuration,
    offsetActiveWeapon,
    offsetAttack;

public void OnPluginStart() 
{
    offsetStart = FindSendPropInfo("CCSPlayer", "m_flProgressBarStartTime");
    offsetDuration = FindSendPropInfo("CCSPlayer", "m_iProgressBarDuration");
    offsetActiveWeapon = FindSendPropInfo("CCSPlayer", "m_hActiveWeapon");
    offsetAttack = FindSendPropInfo("CBaseCombatWeapon", "m_flNextPrimaryAttack");

    if(offsetStart == -1 || offsetDuration == -1 || offsetActiveWeapon == -1 || offsetAttack == -1)
    {
        SetFailState("No offsets found. This game is not supported.");
    }

    HookEvent("weapon_reload", Event_OnWeaponReload);
}

public void OnClientPutInServer(int client)
{
    SDKHook(client, SDKHook_WeaponSwitch, SDKHook_OnWeaponManipulation);
    SDKHook(client, SDKHook_WeaponDrop, SDKHook_OnWeaponManipulation);
}

public void Event_OnWeaponReload(Event event, char[] name, bool dontBroadcast)
{
    static int client, entity;
    static float time;

    client = GetClientOfUserId(event.GetInt("userid"));
    
    if(client)
    {
        entity = GetEntDataEnt2(client, offsetActiveWeapon);
        time = GetEntDataFloat(entity, offsetAttack);
        SendProgressBar(client, time - GetGameTime());
        reload[client] = true;
    }
}

public Action SDKHook_OnWeaponManipulation(int client, int weapon)
{
    if(reload[client])
    {
        ClearScreen(client);
    }

    return Plugin_Continue;
}

public Action Timer_ClearScreen(Handle timer, const int client)
{
    if(IsClientInGame(client))
    {
        ClearScreen(client);
    }

    return Plugin_Stop;
}

void SendProgressBar(const int client, const float time = 0.0)
{
    SetEntDataFloat(client, offsetStart, GetGameTime(), true);
    SetEntData(client, offsetDuration, RoundToCeil(time), true);
    
    if(time)
    {
        CreateTimer(time, Timer_ClearScreen, client);
    }
}

void ClearScreen(const int client)
{
    SendProgressBar(client);
    reload[client] = false;
}